function showMainMenuModal(optionalPage) {
	// NOTE: optionalPage should be a string
	//If mainmenu modal not already open, then open it...
  try {
	if (!!!document.getElementById("mainmenupopup") || !$('#msgboxMainMenu').dialog('isOpen')) {
      // Update height & width according to page.
	  if (typeof optionalPage !== 'undefined') {
		  if (optionalPage === "NewGame" || optionalPage === "NewGameWhileGameRunning") {
			var boxWidth = Math.min(400, $(window).width())
			var boxHeight = 'auto'
		  }
		  // Load Game option opens the load code modal. No need for special code here.
		  // Similarly, if fetish options is selected, it should be calling showPopupJournal('fetishoptions')
		  else if (optionalPage === "Credits") {
			var boxWidth = Math.min(560, $(window).width())
			var boxHeight = 'auto'
		  }
		  else {
		    var boxWidth = 'auto'
			var boxHeight = 'auto'
		  }
	  }
  	  else {
	    var boxWidth = Math.min(280, $(window).width())
	    var boxHeight = 'auto'
	  }
	  
      var msgboxOptions = {
          modal: true,
          autoOpen: false,
		  resizable: false,
		  draggable: false,
          title: "MainMenu",
          width: boxWidth,
		  height: boxHeight,
	  	  show: "scale",
		  hide: "scale",
		  // show: { effect: "drop", direction: "down" },
		  // hide: { effect: "drop", direction: "down" },
          buttons: [],
	  //		{
	  //		    text: 'Return to Main Menu',
	  //		    click: function () { $(this).dialog('close'); }
	  //		},
      //    ],
          closeOnEscape: false,
      };
	  $('#msgboxMainMenu').dialog(msgboxOptions);
	  // Give the messagebox modal an ID to more easily identify whether or not it's open
	  $("div#msgboxMainMenu").parent().attr('id','mainmenupopup');
	  // Make position of dialog box "fixed" rather than "absolute"
	  $('#mainmenupopup').css("position", "fixed");
	  // $('#mainmenupopup').css("top", "25%");
	}
	// Check if optionalPage parameter is set. If it is, open to that page, if not then open to main page
	if (typeof optionalPage !== 'undefined') {
		if (optionalPage =='NewGame' || optionalPage == 'NewGameWhileGameRunning') {
		  $('#msgboxMainMenu').dialog('option', 'title', 'Start New Game?');
		  if (optionalPage=='NewGame') {
		    $('#msgboxMainMenuCaption').html("<div style='font-size:1.1em'>Would you like to start a new game?</div>")
			$('#msgboxMainMenuCaption').append("<table style='width:100%;'><tr><b><td style='text-align:left; padding-left:30%;'><button style='font-size:1.1em;cursor:pointer;' onclick=NewGame('False');>Yes</button></td><td style='text-align:right; padding-right:30%;'><button style='font-size:1.1em;cursor:pointer;' onclick=CloseMainMenuModal();>No</button></td></b></tr></table>")
		  }
		  else {
		    $('#msgboxMainMenuCaption').html("<div style='font-size:1.1em'>Would you like to start a new game?</div><div>(WARNING: All unsaved progress will be lost!)</div>")
			$('#msgboxMainMenuCaption').append("<table style='width:100%;'><tr><b><td style='text-align:left; padding-left:30%;'><button style='font-size:1.1em;cursor:pointer;' onclick=NewGame('True');>Yes</button></td><td style='text-align:right; padding-right:30%;'><button style='font-size:1.1em;cursor:pointer;' onclick=CloseMainMenuModal();>No</button></td></b></tr></table>")
			// TODO: Logic for starting a new game if game already in progress...
		  }
		}
		else if (optionalPage =='Credits') {
		  $('#msgboxMainMenu').dialog('option', 'title', 'Credits');
		  $('#msgboxMainMenu').dialog('option', 'buttons', [{text: 'Return', click: function() {$('#msgboxMainMenu').dialog('close');}}]);
		  // var reader = new FileReader();
		  var CreditsContent = "<p style='text-align:center'>Story & Code by Dredux (DeepDredux)<br><span style='font-size:0.8em'>Music by Eric Matyas (www.soundimage.org)</span><br><br>Check out my social media for the latest updates!<table style='margin-left: auto; margin-right: auto;'> <tr><td style='text-align:right'><b>Twitter:</b></td><td><a href='https://twitter.com/DeepDredux'>@DeepDredux</a></td></tr> <tr><td style='text-align:right'><b>Mastodon:</b></td><td><a href='https://zork.social/@DeepDredux'>@DeepDredux@zork.social</a></td></tr> </table>"
		  
		  CreditsContent = CreditsContent + "<br><div style='text-align:center'>Consider supporting the developer!</div><table style='margin-left: auto; margin-right: auto;'><tr><td style='text-align:right'><b>Tip Jar:</b></td><td><a href='https://ko-fi.com/deepdredux'>Ko-Fi.com/DeepDredux</a></td></tr></table>"
		  
		  CreditsContent = CreditsContent + "</p>"
		  $('#msgboxMainMenuCaption').html(CreditsContent)
		  
		  //$('#msgboxMainMenuCaption').html("<p style='text-align:center'>Story & Code by Dredux (DeepDredux)<br><span style='font-size:0.8em'>Music by Eric Matyas (www.soundimage.org)</span><br><br>Check out my social media for the latest updates!<br><table style='margin-left: auto; margin-right: auto;'> <tr><td style='text-align:right'><b>Twitter:</b></td><td><a href='https://twitter.com/DeepDredux'>@DeepDredux</a></td></tr> <tr><td style='text-align:right'><b>Mastodon:</b></td><td><a href='https://zork.social/@DeepDredux'>@DeepDredux@zork.social</a></td></tr> </table></p>")
		  // TODO: Expand with subscribers, guest writers, links to subscribestar, etc...
		  // <table style='margin-left: auto; margin-right: auto;'><tr><td style='text-align:right'><b>Tip Jar:</b></td><td><a href='https://ko-fi.com/deepdredux'>Ko-Fi.com/DeepDredux</a></td></tr>
		}
		$('#msgboxMainMenu').dialog('open');
	}
	else {
	  // If modal page not defined close the modal
	  $('#msgboxMainMenu').dialog('close');
	}
	// Rerun theme to update buttons and the like
	ASLEvent("ChangeUITheme","Rerun")
  }
  catch(ERROR) {
	console.log(ERROR);
  }
};

function NewGame(GameRunning) {
	// Start a new game
	if (GameRunning=='True') {
	  ASLEvent("StartNewGame","True")
	}
	else {
	  ASLEvent("StartNewGame","False")
	}
	$('body').css('cursor', 'wait');
	// $('#msgboxMainMenu').dialog('close'); // Moved this to the StartNewGame quest function so it only closes when it's actually done.
};

function CloseMainMenuModal() {
	$('#msgboxMainMenu').dialog('close');
};

// 18+ Splash Screen Functions
function Hide18WarningScreen() {
  $('#18WarningScreen').append("<div id='18ThankYou' style='text-align:center'><br><b><i>Thank you. Enjoy your stay in Lillivale...</i> &#9786;</b></div>")
  setTimeout (function() {
    //$('#18WarningScreen').hide({ effect: "scale", origin: [ "bottom", "center" ], duration: 1000 });
    $('#18WarningScreen').hide({ effect: "fade", duration: 1000 , complete: function(){$('#18ThankYou').remove()} });
    //$('#18WarningScreen').css('display','none');
  }, 500)
  setTimeout (function () {
    // Unmute MenuAudio if present. Add delay equal to the start of the fadeout above.
	var audio1 = document.getElementById("MenuAudio1");
    if (typeof optionalPage !== 'audio1') {
	  // Restart audio from beginning
	  audio1.play();
	  audio1.currentTime = 0;
	  audio1.muted = false;
	}
	var audio2 = document.getElementById("MenuAudio2");
    if (typeof optionalPage !== 'audio2') {
	  // Restart audio from beginning
	  audio2.play();
	  audio2.currentTime = 0;
	  audio2.muted = false;
	}
  }, 500)
};

function Show18WarningScreen() {
  $('#18WarningScreen').show();
  //$('#18WarningScreen').css('display','inline');
    setTimeout (function () {
    // Mute MenuAudio if present. Add a delay to give the menu time to initialize
	var audio1 = document.getElementById("MenuAudio1");
	var audio2 = document.getElementById("MenuAudio2");
	if (typeof optionalPage !== 'audio1') {
      audio1.muted = true;
	}
	if (typeof optionalPage !== 'audio2') {
      audio2.muted = true;
	}
  }, 100)
};